function [bed, SNP] = gen_read_bed(fn, nSubj, nSNP)

% mode: 0 = Subj-major, 1 = SNP-major
% SNP:
%   00 = 0 Homozygote "1" / "1"
%   01 = 1 Heterozygote
%   11 = 3 Homozygote "2" / "2"
%   10 = 2 Missing

fid = fopen(fn, 'r');
bed.magic_number = fread(fid, 2, 'uint8');
bed.mode = fread(fid, 1, 'uint8');
if bed.mode == 0,
    nMajor = nSubj;
    nMajor_file = nMajor;
    nMinor = nSNP;
    nMinor_file = ceil(nMinor / 4);
    bed.mode_label = 'Subject-major';
else,
    nMajor = nSNP;
    nMajor_file = ceil(nMajor / 4);
    nMinor = nSubj;
    nMinor_file = nMinor;
    bed.mode_label = 'SNP-major';
end;
SNP = fread(fid, 'ubit2');
fclose(fid);
whos;
SNP = single(SNP);
% Take account of filler-bytes
nMinorF = 4 * ceil(nMinor / 4);
SNP = reshape(SNP, nMinorF, nMajor);
SNP = SNP(1:nMinor, :);
if bed.mode == 0,
    SNP = SNP';
end;
